import { Repository } from 'typeorm';
import { InjectRepository } from '@nestjs/typeorm';
import {
  Inject,
  Injectable,
  InternalServerErrorException,
  NotFoundException,
  UnprocessableEntityException,
} from '@nestjs/common';

import { UseLogger, UseThrowException } from '@api-c3/aop';
import { QueryParamsDto, QueryParserService } from '@api-c3/query-parser';

import { {{EntityName}} } from './entity/{{dashLowerCase EntityName}}.entity';

import { Create{{EntityName}}Dto } from './dto/create-{{dashLowerCase EntityName}}.dto';
import { Update{{EntityName}}Dto } from './dto/update-{{dashLowerCase EntityName}}.dto';


@Injectable()
export class {{EntityName}}Service {
  @Inject()
  private readonly queryParser: QueryParserService;

  @InjectRepository({{EntityName}})
  private readonly {{camelCase EntityName}}Repository: Repository<{{EntityName}}>;

  @UseLogger()
  @UseThrowException(InternalServerErrorException)
  public async count(): Promise<number> {
    return await this.{{camelCase EntityName}}Repository.count();
  }

  @UseLogger()
  @UseThrowException(UnprocessableEntityException)
  public async create(createDto: Create{{EntityName}}Dto): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Repository.save(new {{EntityName}}(createDto));
  }

  @UseLogger()
  @UseThrowException(InternalServerErrorException)
  public async findAll(query: QueryParamsDto): Promise<{{EntityName}}[]> {
    const parsedQuery = this.queryParser.asTypeOrmQuery(query);

    return await this.{{camelCase EntityName}}Repository.find(parsedQuery);
  }

  @UseLogger()
  @UseThrowException(NotFoundException)
  public async findOne(id: string): Promise<{{EntityName}}> {
    return await this.{{camelCase EntityName}}Repository.findOne(id);
  }

  @UseLogger()
  @UseThrowException(UnprocessableEntityException)
  public async update(id: string, updateDto: Update{{EntityName}}Dto): Promise<{{EntityName}}> {
    await this.{{camelCase EntityName}}Repository.update(id, updateDto);
    return await this.{{camelCase EntityName}}Repository.findOne(id);
  }

  @UseLogger()
  @UseThrowException(InternalServerErrorException)
  public async delete(id: string): Promise<{{EntityName}}> {
    const {{camelCase EntityName}} = await this.{{camelCase EntityName}}Repository.findOne(id);

    if (!!{{camelCase EntityName}}) {
      await this.{{camelCase EntityName}}Repository.delete(id);
    }

    return {{camelCase EntityName}};
  }
}